using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Data.SqlServerCe;
using System.Collections;
using System.Runtime.InteropServices;
using Tamir.IPLib;
using Tamir.IPLib.Packets;
using System.Net;
using IpHlpApidotnet;
using homeagain.Properties;

namespace homeagain
{
    public partial class main : Form
    {
        //http://www.codeproject.com/cs/internet/iphlpapi.asp
        
        form1 frm_showdata;
        string query;
        int proccount;
        int result;
        object procremoteid;
        object userid;
        object check = "Unknown";                   //for checking packet port against process list
        Boolean capturing = false;                  //I'm Away has or has not been clicked
        Boolean analyzing = false;                  //Analyze has or has not been clicked
        Boolean configuring = false;                //Settings has or has not been clicked
        PcapDeviceList devices = SharpPcap.GetAllDevices(); //list of all devices
        PcapDevice device;                          //current device
        int devicenum = -1;                         //index of currently selected device
        object[] packetrecord = new object[9];      //holds packet record as we build 
                                                    /* packetrecord[0] = Date
                                                     * packetrecord[1] = PacketLength
                                                     * packetrecord[2] = SourceAddress
                                                     * packetrecord[3] = SourcePort
                                                     * packetrecord[4] = DestinationAddress
                                                     * packetrecord[5] = DestinationPort
                                                     * packetrecord[6] = SourceHostName
                                                     * packetrecord[7] = DestinationHostName
                                                     * packetrecord[8] = Process Name
                                                     */
        object[] curprocessrecord = new object[2];  //holds proc record and used to check for proc existance in proc table
        TCPUDPConnections processlist = new TCPUDPConnections();//holds process list

        public main()
        {
            InitializeComponent();
            //CheckForIllegalCrossThreadCalls = false;
            if (devices.Count < 1) { MessageBox.Show("ERR-D01: No network devices were found.", "Device Error!"); }
        }

        private void device_PcapOnPacketArrival(object sender, Packet packet)
        {
            if (packet is TCPPacket) 
            {   //for now we are only grabbing tcp
                processlist.GetTcpConnections(); //get the process list.  
                TCPPacket tcp = (TCPPacket)packet; //push the packet into a new variable of tcp type
                
                if (tcp.SourceAddress == device.PcapIpAddress || tcp.DestinationAddress == device.PcapIpAddress)
                {   //We should make sure that either source or destination ip is our ip.  
                    //This isn't a sniffer.
                    packetrecord[0] = packet.PcapHeader.Date;
                    packetrecord[1] = packet.PcapHeader.PacketLength;
                    packetrecord[2] = tcp.SourceAddress;
                    packetrecord[3] = tcp.SourcePort;
                    packetrecord[4] = tcp.DestinationAddress;
                    packetrecord[5] = tcp.DestinationPort;

                    if (packetrecord[2].ToString() == device.PcapIpAddress)
                    {   //if we are sending
                        for (int i = 1; i < processlist.Count; i++)
                        {
                            if (packetrecord[3].ToString() == processlist[i].Local.Port.ToString())
                            { check = processlist[i].ProcessName as Object; }
                        }

                        packetrecord[6] = System.Windows.Forms.SystemInformation.UserName.ToString() + "@" + System.Windows.Forms.SystemInformation.UserDomainName.ToString();
                        try
                        {   //try to reverse dns the destination ip
                            System.Net.IPHostEntry destiphost;
                            //destiphost = Dns.GetHostEntry(tcp.DestinationAddress);
                            destiphost = Dns.GetHostByAddress(tcp.DestinationAddress);
                            packetrecord[7] = destiphost.HostName.ToString();
                        }
                        catch
                        {   //if no match was found then just return 
                            packetrecord[7] = "Not Found.";
                        }
                    }
                    else
                    {   //else we are receiving
                        for (int i = 1; i < processlist.Count; i++)
                        {
                            if (packetrecord[5].ToString() == processlist[i].Local.Port.ToString())
                            { check = processlist[i].ProcessName as Object; }
                        }

                        packetrecord[7] = System.Windows.Forms.SystemInformation.UserName.ToString() + "@" + System.Windows.Forms.SystemInformation.UserDomainName.ToString();
                        try
                        {   //try to reverse dns the source ip
                            System.Net.IPHostEntry sourceiphost;
                            //sourceiphost = Dns.GetHostEntry(tcp.SourceAddress);
                            sourceiphost = Dns.GetHostByAddress(tcp.SourceAddress);
                            packetrecord[6] = sourceiphost.HostName.ToString();
                        }
                        catch
                        {   //if no match was found then just return
                            packetrecord[6] = "Not Found.";
                        }
                    }
                    packetrecord[8] = check;  
                

                    
                    
                    try
                    {   //try to load the record into the database
                        packetsDataSet.packetinfo.LoadDataRow(packetrecord, false);
                    }
                    catch
                    {   //snip the hostname size if it won't fit
                        packetrecord[6] = packetrecord[6].ToString().Substring(0, 50);
                        packetrecord[7] = packetrecord[7].ToString().Substring(0, 50);
                        packetsDataSet.packetinfo.LoadDataRow(packetrecord, true);
                    }

                    processDataSet.processRow curprocessrow = processDataSet.process.FindByprocname(packetrecord[8].ToString());
                    if (curprocessrow == null)
                    {   //if curprocessrow is null then no proc in the proc table 
                        //matches the current proc so we should add it.
                        curprocessrecord[0] = packetrecord[8];
                        curprocessrecord[1] = "No Action";
                        processDataSet.process.LoadDataRow(curprocessrecord, false);
                    }
                }
            }
        }

        private void main_Load(object sender, EventArgs e)
        {
           this.packetinfoTableAdapter.Fill(this.packetsDataSet.packetinfo);
            this.processTableAdapter.Fill(this.processDataSet.process);
        }

        private void cmdView_Click(object sender, EventArgs e)
        {
            frm_showdata = new form1();
            frm_showdata.Activate();
            frm_showdata.Show();
        }

        private void cmdCapture_Click(object sender, EventArgs e)
        {
            if (analyzing)
            {   //if the analyze controls are showing, wait on that to finish
                MessageBox.Show("Before capturing, please finish selecting processes you wish to designate as either \"alert\" or \"ignore\" and save your decision by clicking Save.", "Home Again");
            }
            else if (configuring)
            {   //if the settings controls are showing, wait on that to finish
                MessageBox.Show("Before capturing, please finish configuring your settings and click the Save button or click Return to abandon changes.", "Home Again");
            }
            else
            {   //nothing else is currently working, so we can capture
                if (capturing == false)
                {   //if we are not already capturing, we attempt capturing
                    
                    if (Settings.Default.curdevice == -1)
                    {   //default settings have not been changed, we don't know which device to use
                        MessageBox.Show("ERR-D04: No device is selected. Please configure your device.", "Device Error!");
                    }
                    else
                    {   //we have a device to open
                        
                        devicenum = Settings.Default.curdevice;
                        try
                        {   //try in case a device was removed that changes the index of the selected device
                            device = devices[devicenum];
                            //Register our handler function to the 'packet arrival' event
                            device.PcapOnPacketArrival +=
                                new SharpPcap.PacketArrivalEvent(device_PcapOnPacketArrival);
                            //Open the device for capturing
                            //true -- means promiscuous mode
                            //1000 -- means a read wait of 1000ms
                            device.PcapOpen(true, 1);
                            //Start the capturing process
                            device.PcapStartCapture();
                            //minimize the window and change the control
                            WindowState = FormWindowState.Minimized;
                            Hide();
                            capturing = true;
                            cmdCapture.Text = "I'm Back";
                        }
                        catch
                        {
                            MessageBox.Show("ERR-D02: The selected device is not present.  Please reconfigure your device.", "Device Error!");
                        }
                    }
                }
                else
                {
                    capturing = false;
                    cmdCapture.Text = "Saving...";

                    cmdCapture.Enabled = false;
                    cmdAnalyze.Enabled = false;
                    cmdConfigure.Enabled = false;
                    cmdView.Enabled = false;
                    cmdExit.Enabled = false;

                    try
                    {
                        //Stop the capturing process
                        device.PcapStopCapture();
                        //Close the pcap device
                        device.PcapClose();
                    }
                    catch
                    {
                        MessageBox.Show("ERR-D03: You are not currently capturing, please select a device and push Capture in order to capture data.", "Device Error!");
                    }

                    packetinfoBindingSource.EndEdit();
                    packetinfoTableAdapter.Update(packetsDataSet.packetinfo);
                    packetsDataSet.packetinfo.AcceptChanges();

                    processBindingSource.EndEdit();
                    processTableAdapter.Update(processDataSet.process);
                    processDataSet.process.AcceptChanges();

                    cmdCapture.Text = "I'm Away";
                    cmdCapture.Enabled = true;
                    cmdAnalyze.Enabled = true;
                    cmdConfigure.Enabled = true;
                    cmdView.Enabled = true;
                    cmdExit.Enabled = true;
                }
            }
        }


        private void cmdConfigure_Click(object sender, EventArgs e)
        {
            if (capturing)
            {
                MessageBox.Show("You are currently capturing your computer's traffic.  Please complete this session before attempting to analyze processes.", "Home Again");
            }
            else if (analyzing)
            {
                MessageBox.Show("Before configuring your settings, please finish selecting processes you wish to designate as either \"alert\" or \"ignore\" and save your decision by clicking Save.", "Home Again");

            }
            else
            {
                if (configuring)
                {
                    configuring = false;
                    disposeConfigControls();
                    for (int i = 0; i < 50; i++)
                    {
                        Width = Width + -8;
                    }

                    cmdConfigure.Text = "Settings >>";
                }
                else
                {
                    configuring = true;

                    for (int i = 0; i < 100; i++)
                    {
                        Width = Width + 4;
                    }
                    cmdConfigure.Text = "<< Return";
                    createConfigControls();
                    if (devices.Count < 1) { MessageBox.Show("ERR-D01: No network devices were found.  Try restarting the program.", "Device Error!"); }


                    // Scan the devices, adding each found device to the drop down 
                    foreach (PcapDevice dev in devices)
                    {
                        //Description
                        cmbDeviceList.Items.Add(dev.PcapDescription);
                    }
                    if (devices.Count < Settings.Default.curdevice) { MessageBox.Show("ERR-D05: A network device was removed.  Please reselect your device.", "Device Error!"); }
                    else { cmbDeviceList.SelectedIndex = Settings.Default.curdevice; }
                    if (Settings.Default.downloadrules == true) { chkDownload.Checked = true; }
                    if (Settings.Default.uploadrules == true) { chkUpload.Checked = true; }
                    txtUsername.Text = Settings.Default.username;
                    txtPassword.Text = Settings.Default.password;
                    
                }
            }
            
        }

        private void cmdExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void analyze_Click(object sender, EventArgs e)
        {
            if (capturing)
            {
                MessageBox.Show("You are currently capturing your computer's traffic.  Please complete this session before attempting to analyze processes.", "Home Again");
            }
            else if (configuring)
            {
                MessageBox.Show("Before analyzing, please finish configuring your settings and click the Save button or click Return to abandon changes.", "Home Again");

            }
            else
            {
                if (analyzing)
                {
                    analyzing = false;
                    disposeAnalyzeControls();
                    for (int i = 0; i < 50; i++)
                    {
                        Width = Width + -8;
                    }

                    cmdAnalyze.Text = "Analyze >>";
                }
                else
                {
                    analyzing = true;

                    for (int i = 0; i < 100; i++)
                    {
                        Width = Width + 4;
                    }
                    createAnalyzeControls();
                    cmdAnalyze.Text = "<< Return";

                    
                }
            }
        }

        private void createAnalyzeControls()
        {
            
           
            this.dgvAnalyzePanel = new DataGridView();
            this.process = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.actionbox = new System.Windows.Forms.DataGridViewComboBoxColumn();
            this.cmdSave = new System.Windows.Forms.Button();
            this.lblAction = new System.Windows.Forms.Label();
            this.pgrServerConn = new System.Windows.Forms.ProgressBar();

            this.SuspendLayout();
            
            DataGridTableStyle ts = new DataGridTableStyle();

            // 
            // process
            // 
            this.process.DataPropertyName = "procname";
            this.process.HeaderText = "Process";
            this.process.Name = "process";
            this.process.ReadOnly = true;
            //ts.GridColumnStyles.Add(process);

            //
            // actionbox
            //
            this.actionbox.Items.AddRange("No Action", "Ignore", "Alert");
           
            this.actionbox.ReadOnly = false;
            this.actionbox.DataPropertyName = "action";
            this.actionbox.HeaderText = "Action";
            this.actionbox.DropDownWidth = 160;
            this.actionbox.Width = 90;
            this.actionbox.MaxDropDownItems = 3;
            this.actionbox.FlatStyle = FlatStyle.Flat;
            //
            //dgvAnalyzePanel
            //
            
            this.dgvAnalyzePanel.AllowUserToAddRows = false;
            this.dgvAnalyzePanel.AllowUserToDeleteRows = false;
            this.dgvAnalyzePanel.AutoGenerateColumns = false;
            this.dgvAnalyzePanel.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
            this.dgvAnalyzePanel.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
            this.process,
            this.actionbox});
            
            this.dgvAnalyzePanel.DataSource = this.processBindingSource;
            this.dgvAnalyzePanel.Location = new System.Drawing.Point(104, 7);
            this.dgvAnalyzePanel.Name = "dgvAnalyzePanel";
            this.dgvAnalyzePanel.ReadOnly = false;
            this.dgvAnalyzePanel.Size = new System.Drawing.Size(388, 111);
            //this.dgvPacketTable.TabIndex = 6;

            //
            //cmdSave
            //
            this.cmdSave.Location = new System.Drawing.Point(412, 137);
            this.cmdSave.Name = "cmdSave";
            this.cmdSave.Size = new System.Drawing.Size(80, 37);
            this.cmdSave.Text = "Save";
            this.cmdSave.UseVisualStyleBackColor = true;
            this.cmdSave.Click += new System.EventHandler(this.cmdSave_Click);

            //
            // lblAction
            //
            this.lblAction.Location = new System.Drawing.Point(124, 137);
            this.lblAction.Text = "Uploading";
            this.lblAction.Visible = true;
            this.lblAction.Width = 80;
            this.lblAction.Height = 30;

            //
            // pgrServerConn
            //
            this.pgrServerConn.Location = new System.Drawing.Point(205, 137);
            this.pgrServerConn.Width = 200;
            this.pgrServerConn.Minimum = 0;
            this.pgrServerConn.Maximum = 100;
            this.pgrServerConn.Value = 0;
            this.pgrServerConn.ForeColor = Color.Green;

            this.Controls.Add(this.dgvAnalyzePanel);
            this.Controls.Add(this.cmdSave);
            this.Controls.Add(this.lblAction);
            this.Controls.Add(this.pgrServerConn);
            this.ResumeLayout(false);
        }
        private void disposeAnalyzeControls()
        {
            process.Dispose();
            dgvAnalyzePanel.Dispose();
            cmdSave.Dispose();
            lblAction.Dispose();
            pgrServerConn.Dispose();
        }
        private System.Windows.Forms.DataGridView dgvAnalyzePanel;
        private System.Windows.Forms.DataGridViewTextBoxColumn process;
        private System.Windows.Forms.DataGridViewComboBoxColumn actionbox;
        private System.Windows.Forms.Button cmdSave;
        private System.Windows.Forms.Label lblAction;
        private System.Windows.Forms.ProgressBar pgrServerConn;

        private void createConfigControls()
        {
            this.cmbDeviceList = new System.Windows.Forms.ComboBox();
            this.btnSaveConfig = new System.Windows.Forms.Button();
            this.btnCancelConfig = new System.Windows.Forms.Button();
            this.lblDevice = new System.Windows.Forms.Label();
            this.chkUpload = new System.Windows.Forms.CheckBox();
            this.chkDownload = new System.Windows.Forms.CheckBox();
            this.txtUsername = new System.Windows.Forms.TextBox();
            this.txtPassword = new System.Windows.Forms.TextBox();
            this.lblUsername = new System.Windows.Forms.Label();
            this.lblPassword = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // cmbDeviceList
            // 
            this.cmbDeviceList.FormattingEnabled = true;
            this.cmbDeviceList.Location = new System.Drawing.Point(175, 17);
            this.cmbDeviceList.Name = "cmbDeviceList";
            this.cmbDeviceList.Size = new System.Drawing.Size(280, 21);
            this.cmbDeviceList.TabIndex = 0;
            this.cmbDeviceList.SelectedIndexChanged += new System.EventHandler(this.cmbDeviceList_SelectedIndexChanged);
            // 
            // btnSave
            // 
            this.btnSaveConfig.Location = new System.Drawing.Point(299, 152);
            this.btnSaveConfig.Name = "btnSave";
            this.btnSaveConfig.Size = new System.Drawing.Size(75, 23);
            this.btnSaveConfig.TabIndex = 1;
            this.btnSaveConfig.Text = "Save";
            this.btnSaveConfig.UseVisualStyleBackColor = true;
            this.btnSaveConfig.Click += new System.EventHandler(this.btnSaveConfig_Click);
            // 
            // btnCancel
            // 
            this.btnCancelConfig.Location = new System.Drawing.Point(380, 152);
            this.btnCancelConfig.Name = "btnCancel";
            this.btnCancelConfig.Size = new System.Drawing.Size(75, 23);
            this.btnCancelConfig.TabIndex = 2;
            this.btnCancelConfig.Text = "Cancel";
            this.btnCancelConfig.UseVisualStyleBackColor = true;
            this.btnCancelConfig.Click += new System.EventHandler(this.btnCancelConfig_Click);
            // 
            // lblDevice
            // 
            this.lblDevice.AutoSize = true;
            this.lblDevice.Location = new System.Drawing.Point(112, 12);
            this.lblDevice.Name = "lblDevice";
            this.lblDevice.Size = new System.Drawing.Size(57, 26);
            this.lblDevice.TabIndex = 3;
            this.lblDevice.Text = "Monitored \r\nDevice:";
            // 
            // chkUpload
            // 
            this.chkUpload.AutoSize = true;
            this.chkUpload.Location = new System.Drawing.Point(175, 106);
            this.chkUpload.Name = "chkUpload";
            this.chkUpload.Size = new System.Drawing.Size(215, 17);
            this.chkUpload.TabIndex = 4;
            this.chkUpload.Text = "Automatically Upload Rulesets to Server";
            this.chkUpload.UseVisualStyleBackColor = true;
            // 
            // chkDownload
            // 
            this.chkDownload.AutoSize = true;
            this.chkDownload.Location = new System.Drawing.Point(175, 129);
            this.chkDownload.Name = "chkDownload";
            this.chkDownload.Size = new System.Drawing.Size(240, 17);
            this.chkDownload.TabIndex = 5;
            this.chkDownload.Text = "Automatically Download Rulesets from Server";
            this.chkDownload.UseVisualStyleBackColor = true;
            // 
            // txtUsername
            // 
            this.txtUsername.Location = new System.Drawing.Point(175, 45);
            this.txtUsername.Name = "txtUsername";
            this.txtUsername.Size = new System.Drawing.Size(100, 20);
            this.txtUsername.TabIndex = 6;
            // 
            // txtPassword
            // 
            this.txtPassword.Location = new System.Drawing.Point(175, 72);
            this.txtPassword.Name = "txtPassword";
            this.txtPassword.Size = new System.Drawing.Size(100, 20);
            this.txtPassword.TabIndex = 7;
            this.txtPassword.UseSystemPasswordChar = true;
            // 
            // lblUsername
            // 
            this.lblUsername.AutoSize = true;
            this.lblUsername.Location = new System.Drawing.Point(112, 45);
            this.lblUsername.Name = "label1";
            this.lblUsername.Size = new System.Drawing.Size(58, 13);
            this.lblUsername.TabIndex = 8;
            this.lblUsername.Text = "Username:";
            // 
            // lblPassword
            // 
            this.lblPassword.AutoSize = true;
            this.lblPassword.Location = new System.Drawing.Point(112, 72);
            this.lblPassword.Name = "label2";
            this.lblPassword.Size = new System.Drawing.Size(56, 13);
            this.lblPassword.TabIndex = 9;
            this.lblPassword.Text = "Password:";
            
            this.Controls.Add(this.lblPassword);
            this.Controls.Add(this.lblUsername);
            this.Controls.Add(this.txtPassword);
            this.Controls.Add(this.txtUsername);
            this.Controls.Add(this.chkDownload);
            this.Controls.Add(this.chkUpload);
            this.Controls.Add(this.lblDevice);
            this.Controls.Add(this.btnCancelConfig);
            this.Controls.Add(this.btnSaveConfig);
            this.Controls.Add(this.cmbDeviceList);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        private void disposeConfigControls()
        {
            lblPassword.Dispose();
            lblUsername.Dispose();
            txtPassword.Dispose();
            txtUsername.Dispose();
            chkDownload.Dispose();
            chkUpload.Dispose();
            lblDevice.Dispose();
            btnCancelConfig.Dispose();
            btnSaveConfig.Dispose();
            cmbDeviceList.Dispose();
        }
        private System.Windows.Forms.ComboBox cmbDeviceList;
        private System.Windows.Forms.Button btnSaveConfig;
        private System.Windows.Forms.Button btnCancelConfig;
        private System.Windows.Forms.Label lblDevice;
        private System.Windows.Forms.CheckBox chkUpload;
        private System.Windows.Forms.CheckBox chkDownload;
        private System.Windows.Forms.TextBox txtUsername;
        private System.Windows.Forms.TextBox txtPassword;
        private System.Windows.Forms.Label lblUsername;
        private System.Windows.Forms.Label lblPassword;

        private void btnSaveConfig_Click(object sender, EventArgs e)
        {
            Settings.Default.curdevice = devicenum;
            if (chkDownload.Checked == true) { Settings.Default.downloadrules = true; }
            else { Settings.Default.downloadrules = false; }
            if (chkUpload.Checked == true) { Settings.Default.uploadrules = true; }
            else { Settings.Default.uploadrules = false; }
            Settings.Default.username = txtUsername.Text.ToString();
            Settings.Default.password = txtPassword.Text.ToString();
            Settings.Default.Save();
        }

        private void cmbDeviceList_SelectedIndexChanged(object sender, EventArgs e)
        {
            devicenum = cmbDeviceList.SelectedIndex;
        }

        private void btnCancelConfig_Click(object sender, EventArgs e)
        {
            
        }

        private void main_Load_1(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'processDataSet.process' table. You can move, or remove it, as needed.
            this.processTableAdapter.Fill(this.processDataSet.process);

        }
        private void cmdSave_Click(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'processDataSet.process' table. You can move, or remove it, as needed.
            //try
            //{
            if (Settings.Default.uploadrules)
            {
                processBindingSource.EndEdit();
                processTableAdapter.Update(processDataSet.process);
                processDataSet.process.AcceptChanges(); 
                using (SqlConnection sqlconnremote = new SqlConnection(Settings.Default.remoteserverConnectionString))
                {
                    query = "SELECT userid FROM [user] WHERE (username = '" + Settings.Default.username + "') AND (password = '" + Settings.Default.password + "')";
                    SqlCommand sqlcmdremote = new SqlCommand(query, sqlconnremote);

                    sqlconnremote.Open();
                    SqlDataReader readerremote = sqlcmdremote.ExecuteReader();
                    if (readerremote.HasRows)
                    {
                        while (readerremote.Read())
                        {
                            userid = readerremote[0];

                        }

                        readerremote.Close();
                        using (SqlCeConnection sqlconnlocal = new SqlCeConnection(Settings.Default.homeagainConnectionString))
                        {
                            query = "SELECT count(*) FROM process;";
                            proccount = 0;
                            SqlCeCommand sqlcmdlocal = new SqlCeCommand(query, sqlconnlocal);
                            sqlconnlocal.Open();

                            SqlCeDataReader readerlocal = sqlcmdlocal.ExecuteReader();

                            while (readerlocal.Read())
                            {
                                proccount = (int)readerlocal[0];
                            }
                            readerlocal.Dispose();
                            pgrServerConn.Maximum = proccount;
                            
                            query = "SELECT procname, action FROM process;";
                            sqlcmdlocal.CommandText = query;

                            readerlocal = sqlcmdlocal.ExecuteReader();

                            int i = 0;
                            pgrServerConn.Maximum = proccount;
                            while (readerlocal.Read())
                            {
                                query = "SELECT COUNT(*) " +
                                        "FROM  user_proc_bridge INNER JOIN " +
                                        "[proc] ON user_proc_bridge.procid = [proc].procid INNER JOIN " +
                                        "[user] ON user_proc_bridge.userid = [user].userid " +
                                        "WHERE ([proc].procname = N'" + readerlocal[0].ToString() + "') AND ([user].username = N'" + Settings.Default.username + "')";

                                result = 0;
                                sqlcmdremote.CommandText = query;
                                if (sqlconnremote.State == ConnectionState.Closed)
                                {
                                    sqlconnremote.Open();
                                }
                                readerremote = sqlcmdremote.ExecuteReader();
                                while (readerremote.Read())
                                {
                                    result = (int)readerremote[0];
                                }

                                query = "SELECT procid FROM [proc] WHERE (procname = '" + readerlocal[0] + "')";
                                sqlcmdremote.CommandText = query;
                                readerremote.Close();
                                readerremote = sqlcmdremote.ExecuteReader();
                                while (readerremote.Read())
                                {
                                    procremoteid = readerremote[0];
                                }
                                readerremote.Close();

                                if (result == 0)
                                {   //this process for this user is not in the db.  Insert.

                                    query = "SELECT count(*) FROM [proc] WHERE (procname = '" + readerlocal[0] + "')";
                                    sqlcmdremote.CommandText = query;
                                    readerremote = sqlcmdremote.ExecuteReader();
                                    while (readerremote.Read())
                                    {
                                        result = (int)readerremote[0];
                                    }
                                    readerremote.Close();
                                    if (result == 0)
                                    { //this process is not in the proc table.  Insert
                                        query = "INSERT INTO [proc] VALUES ('" + readerlocal[0].ToString() + "','No description.')";
                                        sqlcmdremote.CommandText = query;

                                        sqlcmdremote.ExecuteNonQuery();
                                    }

                                    
                                    query = "INSERT INTO [user_proc_bridge] VALUES ("
                                            + userid.ToString() + ", "
                                            + procremoteid.ToString() + ", '"
                                            + readerlocal[1].ToString() + "')";
                                    sqlcmdremote.CommandText = query;
                                    sqlcmdremote.ExecuteNonQuery();

                                }
                                else
                                {   //this process for this user is in the db. Update.
                                    query = "UPDATE [user_proc_bridge] SET action = '" + readerlocal[1].ToString()
                                            + "' WHERE (userid = " + userid.ToString() + ") AND (procid = "
                                            + procremoteid.ToString() + ")";
                                    sqlcmdremote.CommandText = query;
                                    sqlcmdremote.ExecuteNonQuery();
                                }
                                sqlconnremote.Close();
                                readerremote.Dispose();
                                sqlcmdremote.Dispose();
                                pgrServerConn.Value = i = i + 1;
                            }
                        }
                    }
                    else
                    {
                        readerremote.Dispose();
                        MessageBox.Show("The username or password you have provided is not valid.  Please check your settings.", "Home Again");
                    }
                }
            }

            if (Settings.Default.downloadrules)
            {
                //download current ruleset
            }
            //}
            //catch
            //{
            //couldn't upload or download
            //}
            processBindingSource.EndEdit();
            processTableAdapter.Update(processDataSet.process);
            processDataSet.process.AcceptChanges();  

        }

        private void icoHomeagain_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (FormWindowState.Minimized == WindowState)
            {
                Show();
                WindowState = FormWindowState.Normal;
            }
        }
    }
}